#ifndef Adaptivity_h
#define Adaptivity_h

#include <mvvtp.h>
#include <mvvind.h>
#include <mvmtp.h>

#include "kw_constants.h"
#include "Grid.hh"
#include "Globals.hh"
#include "TranProblem.hh"

extern Globals* globals;

enum strategy { fixed_fraction };

class Adaptivity{
  
 public:
  
  Adaptivity();

  ~Adaptivity(){}

  int SolveTransientProblemAdaptive( TranProblem* primal, TranProblem* dual );

  int SpaceMeshRefinement( MV_Vector<Grid>* GRID, MV_Vector<real>* errMeasure );

 private: 
  
  strategy refinement_strategy;
  
  int no_adaptive_iterations;

  real refine_fraction;

};
  
#endif
