// Copyright (C) 2002 Johan Hoffman and Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Original author: Anders Logg. Added to Kraftwerk 2002-01

#ifndef __EQUATION_HH
#define __EQUATION_HH

#include <kw_constants.h>
#include <Vector.hh>
#include <mvvtp.h>
#include <mvmtp.h>

class ShapeFunction;
class GlobalField;

///
class Equation {

public:
  
  Equation(int nsd);
  ~Equation();

  virtual real IntegrateLHS(ShapeFunction &u, ShapeFunction &v) = 0;
  virtual real IntegrateRHS(ShapeFunction &v) = 0;
  
  /// Returns the number of equations 
  int noEq();
    
  void attachField(GlobalField *Coefficients);
  
protected:
  
  GlobalField *coeff;

  bool variational_multiscale_eddy_viscosity;
  bool smagorinsky_eddy_viscosity;

  int nsd;
  int no_eq;
  int noBF;

  real pi;

  real h;

private:
  
};


#endif
