#ifndef ScaleExtrapolation_h
#define ScaleExtrapolation_h

#include "Globals.hh"
#include "Settings.hh"
#include "kw_constants.h"
#include "GridRelation.h"

class ScaleExtrapolation{
  
 public:
  
  ScaleExtrapolation(){}
  ~ScaleExtrapolation(){}

  MV_Vector<real> ComputeCovariance( MV_Vector<real>* v, MV_Vector<real>* w, GridRelation* gridRel );

  MV_Vector<real> ExtrapolateCovariance( MV_Vector<real>* v, MV_Vector<real>* w, GridRelation* gridRelh22h, 
					 GridRelation* gridRelh24h, GridRelation* gridRel2h24h );
  
  int EstimateReynoldsStresses( MV_ColMat<real>* u, MV_ColMat<real>* tau_h, GridRelation* gridRelh22h, 
				GridRelation* gridRelh24h, GridRelation* gridRel2h24h );
  
  int EstimateNonDivergenceForm( MV_ColMat<real>* u, MV_ColMat<real>* tau_h, GridRelation* gridRelh22h, 
				 GridRelation* gridRelh24h, GridRelation* gridRel2h24h );
  
  int ComputeReynoldsStresses( MV_ColMat<real>* u, MV_ColMat<real>* tau, GridRelation* gridRelh22h, 
			       GridRelation* gridRelh24h, GridRelation* gridRelh28h,
			       GridRelation* gridRel2h28h, GridRelation* gridRel4h28h );	
  
  int ComputeNonDivergenceForm( MV_ColMat<real>* u, MV_ColMat<real>* tau, GridRelation* gridRelh22h, 
				GridRelation* gridRelh24h, GridRelation* gridRelh28h,
				GridRelation* gridRel2h28h, GridRelation* gridRel4h28h );	
  
  
};

#endif

