// Original author: Johan Hoffman. Added to Kraftwerk 2002-01-14.
// Copyright (C) 2002 Johan Hoffman and Anders Logg.
// Licensed under the GNU GPL Version 2.

#include "StatProblem.hh"

//-----------------------------------------------------------------------------
StatProblem::StatProblem(Grid *grid) 
{ 
  this->grid = grid;
  
  globals->Get("current computational level",&compGrid);
  
  //noNodes = (*GRID)(compGrid).GetNoNodes();
  //noElms  = (*GRID)(compGrid).GetNoCells();
  noNodes = grid->GetNoNodes();
  noElms  = grid->GetNoCells();

  settings->Get("dimension",&nsd);
  
  A_assembled = false;
  F_assembled = false;
  
  // FIXME: Should be removed
  debug_mode = true;

  A = new SparseMatrix();

  globals->Set("exact integration", true);
  globals->Get("exact integration", &exact_integration);
}
//-----------------------------------------------------------------------------
StatProblem::~StatProblem() 
{ 
  delete A;
}
//-----------------------------------------------------------------------------
Grid *StatProblem::GetGrid() 
{ 
  return grid;
}
//-----------------------------------------------------------------------------
Grid* StatProblem::GetCompGrid() 
{ 
  //return &(*GRID)(compGrid);
  return grid; 
}
//-----------------------------------------------------------------------------
int StatProblem::GetNoEq()
{ 
  return noeq; 
}
//-----------------------------------------------------------------------------
int StatProblem::AttachFEM(Discretiser* dsc, Equation* eqn)
{
//mapper   = map;
// quadrule = qr;
//element  = elm;
 discrete = dsc;
 equation = eqn;
 
 return 0;
}
//-----------------------------------------------------------------------------
int StatProblem::Set_uk_prev_TS( MV_ColMat<real>* uld ) 
{
  uk_prev_TS = uld;
  
  return 0;
}
//-----------------------------------------------------------------------------
int StatProblem::Set_uk_prev_NL( MV_ColMat<real>* uld ) 
{
  uk_prev_NL = uld;
    
  return 0;
}
//-----------------------------------------------------------------------------
int StatProblem::Set_uk( MV_ColMat<real>* uld ) 
{
  uk = uld;
	
  return 0;
}
//-----------------------------------------------------------------------------
int StatProblem::Set_Uprimal( MV_ColMat<real>* uld ) 
{
  Uprimal = uld;
	
  return 0;
}
//-----------------------------------------------------------------------------
int StatProblem::SetMultiScale( MV_ColMat<real>* uc, MV_ColMat<real>* uf ) 
{
  uk_coarse = uc;
  uk_fine   = uf;
    
  settings->Get("compute projections", &compute_projections);
    
  return 0;
}
//-----------------------------------------------------------------------------
