// Copyright (C) 2002 Johan Hoffman and Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Original author: Hoffman/Logg. Added to Kraftwerk 2002-01

#ifndef __TETLIN_SPACE_HH
#define __TETLIN_SPACE_HH

#include "FunctionSpace.hh"

class FiniteElement;
class TetLinFunction;
class LocalField;

class TetLinSpace: public FunctionSpace{

  TetLinSpace(FiniteElement *element, int nvc);
  ~TetLinSpace();

  void Refill();
  void Refill(int cellnumber);

  real GetGradient(int i, int j);

  friend class TetLinFunction;
  friend class FiniteElement;

protected:

  real **locgrad;

private:

  real IntShapeFunction(int m1);
  real IntShapeFunction(int m1, int m2);
  real IntShapeFunction(int m1, int m2, int m3);
  real IntShapeFunction(int m1, int m2, int m3, int m4);

  real j11,j12,j13,j21,j22,j23,j31,j32,j33;
  real det,d;
  
};


real operator* (const ShapeFunction &v, const ShapeFunction &w);
real operator* (const LocalField &v, const LocalField &w);
real operator* (const ShapeFunction &v, const LocalField &w);
real operator* (const LocalField &v, const ShapeFunction &w);
real operator* (const real a, const ShapeFunction &v);
real operator* (const ShapeFunction &v, const real a);
real operator* (const real a, const LocalField &v);
real operator* (const LocalField &v, const real a);
  
#endif

