// Copyright (C) 2002 Johan Hoffman and Anders Logg.
// Licensed under the GNU GPL Version 2.
//
// Original author: Anders Logg. Added to Kraftwerk 2002-01

#ifndef __EQUATION_POISSON_HH
#define __EQUATION_POISSON_HH

#include <Equation.hh>
#include <ShapeFunction.hh>
#include <TetLinSpace.hh>
#include <Display.hh>

class EquationPoisson: public Equation{
public:

  EquationPoisson():Equation(3){}
  
  real IntegrateLHS(ShapeFunction &u, ShapeFunction &v){
	 return ( u.dx()*v.dx() + u.dy()*v.dy() + u.dz()*v.dz() );
  }
  real IntegrateRHS(ShapeFunction &v){
	 return ( 1.0 );
  }
  
};

#endif
