#include "ProblemPoisson.hh"
#include "EquationPoisson.hh"

//-----------------------------------------------------------------------------
const char *ProblemPoisson::Description()
{
  return "Poisson's equation (3D)";
}
//-----------------------------------------------------------------------------
void ProblemPoisson::Solve()
{
  EquationPoisson equation;
  SparseMatrix A;
  Vector b;
  Vector u;
  KrylovSolver solver;
  Output output("poisson.m",1,1);
	 
  // Set up the discretiser
  Discretiser discretiser(grid,&equation);
  
  // Discretise Poisson's equation
  discretiser.Assemble(&A,&b);

  // Solve the linear system
  solver.Solve(&A,&u,&b);
  
  // Save the solution
  output.SetLabel(0,"Temperature");
  output.AddFrame(grid,&u,0.0);
}
//-----------------------------------------------------------------------------
